commit 19c2bd56876302aebb2bdc20b376395931cd5041
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Thu Sep 3 20:33:14 2020 +0200

    PR fortran/96890 - Wrong answer with intrinsic IALL
    
    The IALL intrinsic would always return 0 when the DIM and MASK arguments
    were present since the initial value of repeated BIT-AND operations was
    set to 0 instead of -1.
    
    libgfortran/ChangeLog:
    
            * m4/iall.m4: Initial value for result should be -1.
            * generated/iall_i1.c (miall_i1): Generated.
            * generated/iall_i16.c (miall_i16): Likewise.
            * generated/iall_i2.c (miall_i2): Likewise.
            * generated/iall_i4.c (miall_i4): Likewise.
            * generated/iall_i8.c (miall_i8): Likewise.
    
    gcc/testsuite/ChangeLog:
    
            * gfortran.dg/iall_masked.f90: New test.
    
    (cherry picked from commit 8eeeecbcc17041fdfd3ccc928161ae86e7f9b456)

diff --git a/gcc/testsuite/gfortran.dg/iall_masked.f90 b/gcc/testsuite/gfortran.dg/iall_masked.f90
new file mode 100644
index 00000000000..33cc4106a1b
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/iall_masked.f90
@@ -0,0 +1,22 @@
+! { dg-do run }
+! PR fortran/96890 - Wrong answer with intrinsic IALL
+program p
+  implicit none
+  integer :: iarr1(0), iarr2(2,2), iarr3(2,2,2)
+  logical :: mask1(0), mask2(2,2), mask3(2,2,2)
+
+  if (     iall(iarr1,    mask1) /=          -1                 ) stop 1
+  if (     iall(iarr1, 1, mask1) /=          -1                 ) stop 2
+
+  iarr2 = reshape ([  1,      2,       3,      4      ], shape (iarr2))
+  mask2 = reshape ([ .true., .false., .true., .false. ], shape (mask2))
+
+  if (any (iall(iarr2, 2, mask2) /=          [1,-1])            ) stop 3
+
+  iarr3 = reshape ([  1,      2,       3,      4,     &
+                      5,      6,       7,      8      ], shape (iarr3))
+  mask3 = reshape ([ .true., .false., .true., .false.,&
+                     .true., .false., .true., .false. ], shape (iarr3))
+
+  if (any (iall(iarr3, 2, mask3) /= reshape ([1,-1,5,-1],[2,2]))) stop 4
+end
diff --git a/libgfortran/m4/iall.m4 b/libgfortran/m4/iall.m4
index df57367c100..8f3b7741486 100644
--- a/libgfortran/m4/iall.m4
+++ b/libgfortran/m4/iall.m4
@@ -35,7 +35,7 @@ ARRAY_FUNCTION(0,
 `  result &= *src;')
 
 MASKED_ARRAY_FUNCTION(0,
-`  result = 0;',
+`  result = ('rtype_name`) -1;',
 `  if (*msrc)
     result &= *src;')
 

